---
title: LargestContentfulPaint
slug: Web/API/LargestContentfulPaint
tags:
  - API
  - Interface
  - Largest Contentful Paint API
  - LargestContentfulPaint
  - Performance
  - Reference
  - Web Performance
---
<div>{{seecompattable}}</div>

<p>The <code>LargestContentfulPaint</code> interface of the Largest Contentful Paint API provides details about the largest image or text paint before user input on a web page. The timing of this paint is a good heuristic for when the main page content is available during load.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt><strong><code>{{domxref("LargestContentfulPaint.element")}}</code></strong></dt>
 <dd>The element that is the current largest contentful paint.</dd>
 <dt><strong><code>{{domxref("LargestContentfulPaint.renderTime")}}</code></strong></dt>
 <dd>The time the element was rendered to the screen. May not be available if the element is a cross-origin image loaded without the <code>Timing-Allow-Origin</code> header.</dd>
 <dt><strong><code>{{domxref("LargestContentfulPaint.loadTime")}}</code></strong></dt>
 <dd>The time the element was loaded.</dd>
 <dt><strong><code>{{domxref("LargestContentfulPaint.size")}}</code></strong></dt>
 <dd>The intrinsic size of the element returned as the area (width * height).</dd>
 <dt><strong><code>{{domxref("LargestContentfulPaint.id")}}</code></strong></dt>
 <dd>The id of the element. This property returns an empty string when there is no id.</dd>
 <dt><strong><code>{{domxref("LargestContentfulPaint.url")}}</code></strong></dt>
 <dd>If the element is an image, the request url of the image.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
 <dt><strong><code>{{domxref("LargestContentfulPaint.toJSON()")}}</code></strong></dt>
 <dd>Returns the above properties as JSON.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The following example shows how to create a {{domxref('PerformanceObserver')}} that listens for <code>largest-contentful-paint</code> entries and logs the LCP value to the console.</p>

<p>This example also demonstrates how to include buffered entries (those that ocurred before <code>observer()</code> was called), which is done by setting the <code>buffered</code> option to <code>true</code>.</p>

<p>Note that in this example data is only sent to the server when the user leaves the tab.</p>

<pre class="brush: js notranslate">// Catch errors since some browsers throw when using the new `type` option.
// https://bugs.webkit.org/show_bug.cgi?id=209216
try {
  let lcp;

  const po = new PerformanceObserver((entryList) =&gt; {
    const entries = entryList.getEntries();
    const lastEntry = entries[entries.length - 1];

    // Update `lcp` to the latest value, using `renderTime` if it's available,
    // otherwise using `loadTime`. (Note: `renderTime` may not be available on
    // image elements loaded cross-origin without the `Timing-Allow-Origin` header.)
    lcp = lastEntry.renderTime || lastEntry.loadTime;
  });

  po.observe({type: 'largest-contentful-paint', buffered: true});

  // Send data to the server.
  addEventListener('visibilitychange', function fn() {
    if (lcp &amp;&amp; document.visibilityState === 'hidden') {
      console.log('LCP:', lcp);
      removeEventListener('visibilitychange', fn, true);
    }
  }, true);
} catch (e) {
  // Do nothing if the browser doesn't support this API.
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Largest Contentful Paint','#sec-largest-contentful-paint-interface','LargestContentfulPaint')}}</td>
   <td>{{Spec2('Largest Contentful Paint')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.LargestContentfulPaint")}}</p>
